(defvar efsmproverdir "~/Research/Software/efsmtool-fork/efsminferencetool/EFSMTool/proofgeneral-integration/")

(defun initialise-sepia ()
  (addmenus))

(require 'cl)

(add-to-list 'auto-mode-alist
	     '("\\.v\\'" . (lambda ()
			     (progn (coq-mode) (delete-other-windows) (previous-buffer) (previous-buffer) (initialise-sepia)))))

(defun addmenus ()
  (easy-menu-define efsm-menu global-map "SEPIA"
    '("SEPIA"
      ["Prove Current Lemma" (proof-setup)]
      ("MINT Options"
       ("Inference Strategy"
	["redblue" ()]
	["noloops" ()]
	["exhaustive" ()]
	)
       ("K-Value"
	["0" ()]
	["1" ()]
	["2" ()]))
    ("Search Limits"
     ["10,000" ()]
     ["25,000" ()]
     ["50,000" ()]
     ["Until Completion" ()])
     ))
  (easy-menu-remove-item global-map '("menu-bar") "SEPIA")
  (easy-menu-add-item nil nil efsm-menu "help-menu"))

(defun proof-setup ()
  (point)
  (re-search-backward "Lemma\\|Theorem" )
  (setq myLine "")
  
  ;;this simple loop is what we need to do to find the lemma statement...
  (setq cont 1)
  (while (= cont 1)
  	(message "continuing")
  	(setq cont 0))
  	
  	;;the following loop needs looking into and replacing
  (while (progn
	    (setq p1 (line-beginning-position) )
	    (setq p2 (line-end-position) )
	    (setq thisline (s-trim (buffer-substring-no-properties p1 p2)))
	    (setq myLine (concat myLine thisline " "))
            (forward-line 1)
            (not (looking-at "^[^\.]+\.\n$"))))
  (message myLine)
  (setq myLine (replace-regexp-in-string "Proof\." "" myLine))
  (message myLine)
  (communicate-with-external-commmand))

(defun communicate-with-external-commmand ()
  (save-buffer)
  (setq maintheory (buffer-file-name))
  (get-loaded-theories (buffer-list))
  (setq currentbuffer (buffer-name))
      (with-output-to-temp-buffer "*efsmprover-output*"
    (shell-command (concat "java"
                           " -cp "
			   efsmproverdir
			   "EFSMTool-1.0-SNAPSHOT-jar-with-dependencies.jar"
			   " org.bitbucket.efsmtool.proofs.utilities.ProofGeneralEntry"
			   " -lemmastatement "
			   (concat "\""  myLine "\"")
			   " -maintheory "
			   maintheory
			   " -additionaltheories "
			   othertheories
                           )
                   "*efsmprover-output*"
                   "*efsmprover-output*")
    (pop-to-buffer "*efsmprover-output*"))
      (highlight-lines-matching-regexp "^.*Proof was:.*$" 'hi-green-b)
      (highlight-lines-matching-regexp "^.*Exhausted.*$" 'hi-red-b))

(defun get-loaded-theories (list)
  (setq othertheories "")
  (while list
    (setq elem (buffer-file-name (car list)))
    (if (string= elem "nil")
	(setq list (cdr list))
      (when (string-match ".*\.v$" elem)
	(if (string= elem maintheory)
	    ()
	  (setq othertheories (concat othertheories " " elem))))
      (setq list (cdr list)))))
      
      
      
      
      (defun s-trim-left (s)
  (if (string-match "\\`[ \t\n\r]+" s)
      (replace-match "" t t s)
    s))

(defun s-trim-right (s)
  (if (string-match "[ \t\n\r]+\\'" s)
      (replace-match "" t t s)
    s))

(defun s-trim (s)
  (s-trim-left (s-trim-right s)))

